#include <stdio.h>
#include <stddef.h>
#include "wgrib2.h"


#define BSIZ (1024*4)

extern int ieee_little_endian;

int rdieee_file(float *array, int n, int header, FILE *input) {

	int i, j;
	unsigned int l;
	unsigned char buff[BSIZ];
	unsigned char h4[4];
	float *p;

	if (header) {
		if (fread(h4,1,4,input) != 4) fatal_error("rdieee: header read","");
		if (ieee_little_endian) 
			l = (h4[3] << 24) | (h4[2] << 18) | (h4[1] << 8) | h4[0];
		else
			l = (h4[0] << 24) | (h4[1] << 18) | (h4[2] << 8) | h4[3];
			
		if (l != n*4) fatal_error_i("rdieee: bad header=%u",l);
	}

	n = n*4;
	p = array;

	while (n > 0) {
		j =  n < BSIZ ? n : BSIZ;
		fread(buff,1,j,input);
		if (ieee_little_endian) swap_buffer(buff, j);
		for (i = 0; i < j; i += 4) {
		    *p++ = ieee2flt(buff + i);
		}
		n = n - j;
	}
	if (header) {
		if (fread(h4,1,4,input) != 4) fatal_error("rdieei: header read","");
		if (ieee_little_endian) 
			l = (h4[3] << 24) | (h4[2] << 18) | (h4[1] << 8) | h4[0];
		else
			l = (h4[0] << 24) | (h4[1] << 18) | (h4[2] << 8) | h4[3];
			
		if (l != n*4) fatal_error_i("rdieee: bad header=%u",l);
	}

	return 0;
}
